// Folded map
// VOGEL BROTHERS
// Rocking hard
#include <iostream>
#include <sstream>
using namespace std;
#define INT_MAX 1000000

bool * map = 0;
//dimensions
int Ar, Ac, Tr, Tc;
//extremes
int north, south, west, east;
// used tiles, garden size
int Uc, Ur, Gc, Gr;
// variations
int Vc, Vr;

int mi (int x, int y) {
	return Ac * y + x;
}

bool testTile (int tStartC, int tStartR) {
	for (int i = tStartR; i < tStartR + Tr; i++)
		for (int j = tStartC; j < tStartC + Tc; j++)
			if (i < Ar && i >= 0 && j < Ac && j >= 0)
				if ( map[mi(j, i)] ) return true;
	return false;
}

int testVariation (int Oc, int Or) {
	int usedTiles = 0;
	for (int i = 0; i < Ur; i++)
		for (int j = 0; j < Uc; j++) {
			if (testTile (Oc + j * Tc, Or + i * Tr)) usedTiles++;
		}
	return usedTiles;
}

bool loadMap () {
	cout << "loading map..." << endl;
	string str = "";
	if (! getline (cin, str) ) return false;
	istringstream ss;
	ss.str(str);
	ss >> Ar >> Ac >> Tr >> Tc;
	cout << Ar << " " << Ac << " " << Tr << " "<< Tc << endl; 
	// init extremes
	north = Ar;
	south = 0;
	west = Ac;
	east = 0;

	map = new bool [Ar * Ac];
	char * row = new char [Ac + 2];
	for (int i = 0; i < Ar; i++) {
		cin.getline(row, Ac + 2);
		for (int j = 0 ; j < Ac; j++) {
			if (row[j] == '.')
				map[mi(i,j)] = false;
			else {
				map[mi(i,j)] = true;
				if (north > i) north = i;
				if (south < i) south = i;
				if (east < j)  east = j;
				if (west > j)  west = j;
			}
		}
	}
	delete [] row;
	cout << "Extremes nsew>" << north << " " << south << " " << east << " " << west << endl;
	return true;
}

int analyzeMap () {
	// calculate number of tiles
	Gc = east - west + 1;
	Gr = south - north + 1;

	Uc = Gc / Tc;
	Vc = Gc % Tc;
	if (Vc) {Uc++;
	Vc = Tc - Vc;}

	Ur = Gr / Tr;
	Vr = Gr % Tr;

	if (Vr) {Ur++;
	Vr = Tr - Vr;}
	cout << "Map analyze Gc Gr Vc Vr Uc Ur " << Gc << " " << Gr << " " << Vc << " " << Vr << " " << Uc << " " << Ur << endl;

	// test each variation
	int bestResult = INT_MAX;

	for (int i = 0; i < Vr; i++)
		for (int j = 0; j< Vc; j++) {
			int varRes = testVariation(0-j,0-i);
			if (varRes<bestResult) bestResult = varRes;
		}

	delete [] map;
	return bestResult;
}


int main () {
	while (loadMap())
	//loadMap();
			cout << analyzeMap() << endl;
	return 0;
}


